# AutoGear

## [2022-10-29-release](https://github.com/AlexFolland/AutoGear/tree/2022-10-29-release) (2022-10-30)
[Full Changelog](https://github.com/AlexFolland/AutoGear/compare/2022-10-16-release...2022-10-29-release) [Previous Releases](https://github.com/AlexFolland/AutoGear/releases)

- fix CLI commands  
- - if there's any item data missing, don't do anything that matters and instead try updating again  
    - remove some unnecessary comments  
- - implement opening the options menu properly without calling the InterfaceOptionsPanel\_OpenToCategory function twice  
    - minor optimization  
    - remove some old comments which include commented debug logs and other unnecessary code  
    - add Pawn value to debug tooltip  
- - prevent rolling on excess copies of upgrades which are not equippable due to being a few levels higher  
    - improve aesthetics of `/ag pawnscale` output message  
    - use Enum.InventoryType values instead of raw numbers when looking up valid gear slots for future-proofing  
    - use Enum.InventoryType values instead of old-style itemEquipLoc values for checking weapon types  
    - use Enum.ItemClass.Weapon, Enum.ItemClass.Armor, Enum.ItemWeaponSubclass, and Enum.ItemArmorSubclass values for determining item types for weapons, shields, and fishing poles  
    - rename gearType to invType to match Blizzard's scheme  
    - use Enum.ItemClass.Miscellaneous and Enum.ItemMiscellaneousSubclass.Mount values instead of raw numbers for determining whether an item is a mount  
    - add Pawn scale localized name to tooltip debug info  
    - add item level to tooltip debug info  
- - detect, roll on, and equip bag upgrades (non-generic bags are considered near-worthless; epsilon times the number of slots)  
    - prevent rolling on mounts which have been already collected and/or learned by the player  
    - value gear which score 0 more than empty equipment slots  
    - when building the internal list of best items, first find the lowest-scoring valid equipment slot and do comparisons against that  
    - fill localized class list differently depending on player sex  
    - add Evoker to class list (but no weights)  
    - add class ID list for class ID lookups (not currently used)  
    - rename some functions for development clarity  
    - change all zeroes in built-in weights to E (epsilon, a non-zero value that's as close to zero as possible; useful for valuing stats which are otherwise worthless)  
    - maintain a table of equipped items to more efficiently evaluate upgrades  
    - reduce superfluous calls to AutoGearSetStatWeights()  
    - add options stub for gear-slot locking, but mention it is not yet implemented in its tooltip  
    - change scope of all remaining accidental global variables to local  
    - improve accuracy and aesthetics of message printed by `/ag spec` command  
    - remove some unnecessary debug print commands  
    - wrap override spec in its class color code when printed to the chat  
    - rename some local variables to begin with lower case  
    - differentiate between Pawn being not installed and not ready yet when failing to set Pawn scale  
    - future-proof check for equipped fishing pole by querying item class ID and subclass ID instead of looking for "Fishing Pole" or "Fishing Poles" strings  
    - reduce usage of unnecessary parentheses in conditional checks  
    - when printing item messages, fall back to name if link is not available  
    - when gathering info about an item, first check bag and slot, then equipment slots, then rolls and other locations, which is a minor optimization since items in the bags and equipment slots are more plentiful than elsewhere  
    - detect mount items by item class ID and item subclass ID constants instead of raw numbers  
    - when gathering info about an item, return early if the item is not gear or a mount, which is a major optimization  
    - only gather information about weapons if the item is a weapon, which is a minor optimization  
    - use constants for future-proofing bag equipment slot IDs  
    - several other trivial improvements for development and optimization  
- bag equipping!  
- re-enable loot roll simulation in debug-enabled tooltips  
- allow replacing unusable items, optimize several key pain points, partial mega refactor, and add incomplete locked slots implementation  
- add populated Author field to TOC files  
